'use strict';

var _ = require('underscore-contrib');

// [Notch]
var list = [
  {id: 'r', level: 1},
  {id: 'a', level: 2},
  {id: 'b', level: 2},
  {id: 'c', level: 3},
  {id: 'd', level: 3},
  {id: 'e', level: 2},
  {id: 'f', level: 3},
  {id: 'g', level: 4},
];

console.log('list:');
console.log(list);

function treeify(list) {
  return _(list)
    .map(function(node, index) {
      var parent = _.findWhere(list.slice(0, index).reverse(), {level: node.level - 1});
      return _.extend(node, {
        children: [],
        parent: parent
      });
    })
    .reduce(function(roots, node) {
      if (node.parent)
        node.parent.children.push(node);
      else
        roots.push(node);
      return roots;
    }, []);
}

console.log(require('util').inspect(treeify(list), false, null, true));


